package org.jeecg.modules.database.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.database.dto.NasaDataRecordPage;
import org.jeecg.modules.database.entity.NasaDataRecord;
import org.jeecg.modules.database.service.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;

/**
 * @Description: NASA数据管理
 * @Author: jeecg-boot
 * @Date: 2024-11-04
 * @Version: V1.0
 */
@Tag(name = "NASA数据管理")
@RestController
@RequestMapping("/database/nasaDataRecord")
@Slf4j
public class NasaDataRecordController extends JeecgController<NasaDataRecord, INasaDataRecordService> {
    @Autowired
    private INasaDataRecordService     nasaDataRecordService;
    @Autowired
    private IHistoricalDatabaseService historicalDatabaseService;
    @Autowired
    private ILocalDatabaseService      localDatabaseService;

    /**
     * 分页列表查询
     *
     * @param nasaDataRecord
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    //@AutoLog(value = "NASA数据管理-分页列表查询")
    @Operation(summary = "NASA数据管理-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<NasaDataRecord>> queryPageList(NasaDataRecord nasaDataRecord,
                                                       @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                       @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                       HttpServletRequest req) {
        QueryWrapper<NasaDataRecord> queryWrapper = QueryGenerator.initQueryWrapper(nasaDataRecord, req.getParameterMap());
        Page<NasaDataRecord> page = new Page<NasaDataRecord>(pageNo, pageSize);
        IPage<NasaDataRecord> pageList = nasaDataRecordService.page(page, queryWrapper);

        for (NasaDataRecord nr : pageList.getRecords()) {
            String fileList = nr.getFileList();
            if (StringUtils.isNotBlank(fileList)) {
                List<Map<String, String>> list = JSON.parseObject(fileList, new TypeReference<>() {});
                Map<String, String> files = new HashMap<>();
                list.forEach(files::putAll);
                nr.setFileMap(files);
            }
        }
        return Result.OK(pageList);
    }

    @Operation(summary = "外网数据统计")
    @GetMapping(value = "/statistics")
    public Result<NasaDataRecordPage> statistics() {
        NasaDataRecordPage result = new NasaDataRecordPage();
        Long nasaCountLhs = nasaDataRecordService.sumLhs();
        Long nasaCountXhy = nasaDataRecordService.sumXhy();
        Long historicalCountLhs = historicalDatabaseService.sumLhs();
        Long historicalCountXhy = historicalDatabaseService.sumXhy();
        Long localCountLhs = localDatabaseService.sumLhs();
        Long localCountXhy = localDatabaseService.sumXhy();

        result.setLhsCount(nasaCountLhs);
        result.setLhsTotal(nasaCountLhs + localCountLhs + historicalCountLhs);
        result.setXhyCount(nasaCountXhy);
        result.setXyhTotal(nasaCountXhy + localCountXhy + historicalCountXhy);

        return Result.OK(result);
    }

    /**
     * 添加
     *
     * @param nasaDataRecord
     * @return
     */
    @AutoLog(value = "NASA数据管理-添加")
    @Operation(summary = "NASA数据管理-添加")
    @RequiresPermissions("database:nasa_data_record:add")
    @PostMapping(value = "/add")
    public Result<String> add(@RequestBody NasaDataRecord nasaDataRecord) {
        nasaDataRecordService.save(nasaDataRecord);
        return Result.OK("添加成功！");
    }

    @GetMapping(value = "/fix")
    public Result<String> fix() {
        List<NasaDataRecord> list = nasaDataRecordService.list();
        list.forEach(nr -> {
            String fileList = nr.getFileList();
            if (StringUtils.isNotBlank(fileList)) {
                List<Map<String, String>> list1 = JSON.parseObject(fileList, new TypeReference<>() {});
                Map<String, String> files = new HashMap<>();
                list1.forEach(files::putAll);
                nr.setFileMap(files);
                nr.setFileList(JSON.toJSONString(files));
                nasaDataRecordService.updateById(nr);
            }
        });
        return Result.OK("fix成功！");
    }

    /**
     * 编辑
     *
     * @param nasaDataRecord
     * @return
     */
    @AutoLog(value = "NASA数据管理-编辑")
    @Operation(summary = "NASA数据管理-编辑")
    @RequiresPermissions("database:nasa_data_record:edit")
    @RequestMapping(value = "/edit", method = {RequestMethod.PUT, RequestMethod.POST})
    public Result<String> edit(@RequestBody NasaDataRecord nasaDataRecord) {
        Map<String, String> fileMap = nasaDataRecord.getFileMap();
        if (Objects.nonNull(fileMap)) {
            nasaDataRecord.setFileList(JSON.toJSONString(fileMap));
        }
        nasaDataRecordService.updateById(nasaDataRecord);
        return Result.OK("编辑成功!");
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "NASA数据管理-通过id删除")
    @Operation(summary = "NASA数据管理-通过id删除")
    @RequiresPermissions("database:nasa_data_record:delete")
    @DeleteMapping(value = "/delete")
    public Result<String> delete(@RequestParam(name = "id", required = true) String id) {
        nasaDataRecordService.removeById(id);
        return Result.OK("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "NASA数据管理-批量删除")
    @Operation(summary = "NASA数据管理-批量删除")
    @RequiresPermissions("database:nasa_data_record:delete")
    @DeleteMapping(value = "/deleteBatch")
    public Result<String> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        this.nasaDataRecordService.removeByIds(Arrays.asList(ids.split(",")));
        return Result.OK("批量删除成功!");
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    //@AutoLog(value = "NASA数据管理-通过id查询")
    @Operation(summary = "NASA数据管理-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<NasaDataRecord> queryById(@RequestParam(name = "id", required = true) String id) {
        NasaDataRecord nasaDataRecord = nasaDataRecordService.getById(id);
        if (nasaDataRecord == null) {
            return Result.error("未找到对应数据");
        }
        String fileList = nasaDataRecord.getFileList();
        if (StringUtils.isNotBlank(fileList)) {
            List<Map<String, String>> list = JSON.parseObject(fileList, new TypeReference<>() {});
            Map<String, String> files = new HashMap<>();
            list.forEach(files::putAll);
            nasaDataRecord.setFileMap(files);
        }
        return Result.OK(nasaDataRecord);
    }

    /**
     * 导出excel
     *
     * @param request
     * @param nasaDataRecord
     */

    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, NasaDataRecord nasaDataRecord) {
        return super.exportXls(request, nasaDataRecord, NasaDataRecord.class, "NASA数据管理");
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequiresPermissions("database:nasa_data_record:add")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, NasaDataRecord.class);
    }

}
